Pull out rocky patches
[fuel.git] / mcp / config / states / maas
index 0d733ba..47f66a4 100755 (executable)
-#!/bin/bash
-set -x
-
-function wait_for() {
-  local total_attempts=$1; shift
-  local cmdstr=$*
-  local sleep_time=10
-  echo "[NOTE] Waiting for cmd to return success: ${cmdstr}"
-  # shellcheck disable=SC2034
-  for attempt in $(seq "${total_attempts}"); do
-    # shellcheck disable=SC2015
-    eval "${cmdstr}" && break || true
-    echo -n '.'; sleep "${sleep_time}"
-  done
-}
-
-# Wait for MaaS commissioning/deploy to finish, retry on failure
-function maas_fixup() {
-  local statuscmd="salt 'mas01*' --out yaml state.apply maas.machines.status"
-  wait_for 180 "${statuscmd} | tee /dev/stderr | " \
-           "grep -Eq '((Deployed|Ready): 5|status:Failed|status:Allocated)'"
-  # shellcheck disable=SC2155
-  local statusout=$(eval "${statuscmd}")
-
-  # shellcheck disable=SC2155
-  local fcnodes=$(echo "${statusout}" | \
-    grep -Po '(?<=system_id:)(.*)(?=,status:Failed commissioning)')
-  for node_system_id in ${fcnodes}; do
-    salt -C 'mas01*' state.apply maas.machines.delete \
-      pillar="{'system_id': '${node_system_id}'}"
-  done
-  if [ -n "${fcnodes}" ]; then
-    salt -C 'mas01*' state.apply maas.machines
-    return 1
-  fi
-
-  # shellcheck disable=SC2155
-  local fdnodes=$(echo "${statusout}" | \
-    grep -Po '(?<=system_id:)(.*)(?=,status:(Failed deployment|Allocated))')
-  for node_system_id in ${fdnodes}; do
-    salt -C 'mas01*' state.apply maas.machines.mark_broken_fixed \
-      pillar="{'system_id': '${node_system_id}'}"
+#!/bin/bash -e
+# shellcheck disable=SC1090
+##############################################################################
+# Copyright (c) 2018 Mirantis Inc., Enea AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
+ERASE_ENV=${ERASE_ENV:-0}
+
+source "$(dirname "${BASH_SOURCE[0]}")/../../scripts/globals.sh"
+source "$(dirname "${BASH_SOURCE[0]}")/../../scripts/lib.sh"
+
+bm_nodes=$(salt --out yaml 'mas01*' pillar.get maas:region:machines | \
+           awk '/^\s+\w+[[:digit:]]+:$/ {gsub(/:$/, "*"); printf "%s ", $1}')
+
+# Optionally destroy MaaS machines from a previous run
+if [ "${ERASE_ENV}" -gt 1 ]; then
+  cleanup_uefi
+  for node_hostname in ${bm_nodes//\*/}; do
+    salt -C 'mas01*' maasng.delete_machine "${node_hostname}" || true
   done
-  if [ -n "${fdnodes}" ]; then
-    salt -C 'mas01*' state.apply maas.machines.deploy
-    return 1
-  fi
-
-  return 0
-}
+fi
 
 # MaaS rack/region controller, node commissioning
-salt -C 'mas01*' cmd.run "add-apt-repository ppa:maas/stable"
-
-salt -C 'mas01*' state.apply linux,salt,openssh,ntp
-salt -C 'mas01*' state.apply linux.network.interface
-salt -C 'mas01*' state.apply maas.pxe_nat
+wait_for 10.0 "salt -C 'mas01*' state.apply linux,salt,openssh,ntp,iptables"
 salt -C 'mas01*' state.apply maas.cluster
-salt -C 'cfg01*' state.apply maas.pxe_route
 
 wait_for 10 "salt -C 'mas01*' state.apply maas.region"
 
-salt -C 'mas01*' state.apply maas.machines
-wait_for 10 maas_fixup
+if [ -n "${bm_nodes}" ]; then
+  salt -C 'mas01*' state.apply maas.machines
+fi
 
 # cleanup outdated salt keys
+sleep 30
 salt-key --out yaml | awk '!/^(minions|- cfg01|- mas01)/ {print $2}' | \
-  xargs -I{} salt-key -yd {}
+  xargs --no-run-if-empty -I{} salt-key -yd {}
 
 # MaaS node deployment
-salt -C 'mas01*' state.apply maas.machines.deploy
-wait_for 10 maas_fixup
-
-salt -C 'mas01*' pillar.item\
-  maas:region:admin:username \
-  maas:region:admin:password
-
-# KVM, compute node prereqs (libvirt first), VCP deployment
-salt -C '* and not cfg01* and not mas01*' saltutil.sync_all
-
-salt -C 'kvm*' pkg.install bridge-utils
-salt -C 'kvm*' state.apply linux.network
-salt -C 'kvm*' system.reboot
-wait_for 90 "! salt 'kvm*' test.ping | tee /dev/stderr | fgrep -q 'Not connected'"
-
-salt -C '* and not cfg01* and not mas01*' state.apply linux,ntp
-
-salt -C 'kvm*' state.sls libvirt
-
-salt -C '* and not cfg01* and not mas01*' state.apply salt
-salt -C 'kvm*' saltutil.sync_all
-salt -C 'kvm*' state.sls salt.control
-
-vcp_nodes=$(salt --out yaml 'kvm01*' pillar.get salt:control:cluster:internal:node | \
-            awk '/\s+\w+:$/ {gsub(/:$/, "*"); print $1}')
-
-# Check all vcp nodes are available
-rc=1
-while [ $rc -ne 0 ]; do
-  rc=0
-  for node in $vcp_nodes; do
-    salt "$node" test.ping 2>/dev/null || { rc=$?; break; };
-  done
-  sleep 5
-done
-
-wait_for 10 "salt -C '* and not cfg01* and not mas01*' saltutil.sync_all"
-wait_for 10 "salt -C 'E@^(?!cfg01|mas01|kvm|cmp00).*' state.apply salt"
-wait_for 10 "! salt -C 'E@^(?!cfg01|mas01|kvm|cmp00).*' state.apply linux,ntp | " \
-  "tee /dev/stderr | fgrep -q 'Not connected'"
-
-wait_for 10 "salt -C 'E@^(?!cfg01|mas01|kvm|cmp00).*' ssh.set_auth_key ${SUDO_USER} \
-  $(awk 'NR==1{print $2}' "$(eval echo "~${SUDO_USER}/.ssh/authorized_keys")")"
+if [ -n "${bm_nodes}" ]; then
+  notify "[NOTE] MaaS operations might take a long time, please be patient" 2
+  salt -C 'mas01*' state.apply maas.machines.wait_for_ready_or_deployed
+  salt -C 'mas01*' state.apply maas.machines.storage
+  salt -C 'mas01*' state.apply maas.machines.deploy
+  salt -C 'mas01*' state.apply maas.machines.wait_for_deployed
+fi
+
+# Check all baremetal nodes are available
+wait_for 10.0 "(for n in ${bm_nodes}; do salt \${n} test.ping 2>/dev/null || exit; done)"
+
+wait_for 10.0 "salt -C '* and not cfg01* and not mas01*' saltutil.sync_all"